VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ComparatorExporter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private outWB_ As Excel.Workbook
Private outCmp_ As Excel.Worksheet

Private src1_ As Visio.Page
Private src2_ As Visio.Page

Private sourceNames_ As New Collection

Public Function Init(iDestination As Excel.Workbook)
  Set outWB_ = iDestination
End Function

Public Function RunCompare(src1 As Visio.Page, src2 As Visio.Page)
  Dim out1_ As New API_XLRecordsWrapper: Call out1_.Init(outWB_.Sheets(1))
  Dim out2_ As New API_XLRecordsWrapper: Call out2_.Init(outWB_.Sheets(2))
  Dim items1 As Collection: Set items1 = ScanDataFrom(src1, out1_)
  Dim items2 As Collection: Set items2 = ScanDataFrom(src2, out2_)
  Call OutputComparison(items1, items2)
End Function

' =============
Private Function ScanDataFrom(src As Visio.Page, ByRef out As API_XLRecordsWrapper) As Collection
  Set ScanDataFrom = New Collection
  
  Dim aShape As Visio.Shape
  For Each aShape In src.Shapes
    If aShape.OneD Then _
      GoTo NEXT_SHAPE
    
    Dim theType As ShapeType: theType = GetShapeType(aShape)
    If theType = STYPE_GRID Or theType = STYPE_UNKNOWN Then _
      GoTo NEXT_SHAPE
    
    out.Field(XL_TS_ID) = aShape.ID
    
    If theType = STYPE_DERIVED Then
      out.Field(XL_TS_NAME) = VBA.Trim(aShape.Shapes(S_D_TERM).Text)
      out.Field(XL_TS_DEFINITION) = aShape.Shapes(S_D_DEFINITION).Text
      out.Field(XL_TS_DEFINITION).WrapText = False
    Else
      out.Field(XL_TS_NAME) = Trim(aShape.Text)
    End If
    
    Call SafeAddToCollection(out.Field(XL_TS_NAME), out.Field(XL_TS_NAME), ScanDataFrom)
    Call out.MoveNext
NEXT_SHAPE:
  Next aShape
End Function

Private Function OutputComparison(src1 As Collection, src2 As Collection)
  Dim out1_ As New API_XLRecordsWrapper: Call out1_.Init(outWB_.Sheets(3))
  Dim out2_ As New API_XLRecordsWrapper: Call out2_.Init(outWB_.Sheets(3))
  Dim outCommon_ As New API_XLRecordsWrapper: Call outCommon_.Init(outWB_.Sheets(3))
  
  Dim strItem As Variant
  For Each strItem In src1
    If InCollection(CStr(strItem), src2) Then
      outCommon_.Field(XL_COMP_SHARED) = strItem
      Call outCommon_.MoveNext
    Else
      out1_.Field(XL_COMP_1ST) = strItem
      Call out1_.MoveNext
    End If
  Next strItem
  
  For Each strItem In src2
    If Not InCollection(CStr(strItem), src1) Then
      out2_.Field(XL_COMP_2ND) = strItem
      Call out2_.MoveNext
    End If
  Next strItem
End Function
