Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  EM_INVALID_LEVEL
  EM_EMPTY_SELECTION
  EM_INVALID_FILE_FORMAT
  EM_TEMPLATE_MISSING
  EM_INVALID_WIDTH
  EM_PYTHON_ERROR
  
  IM_GENEARION_COMPLETE
  IM_EXPORT_DIFF_COMPLETE
  IM_EXPORT_XL_COMPLETE

  QM_CLEAR_ALL
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_INVALID_LEVEL:          Call MsgBox("  ", vbExclamation)
  Case EM_EMPTY_SELECTION:        Call MsgBox("    -!", vbExclamation)
  Case EM_INVALID_FILE_FORMAT:    Call MsgBox("Invalid file format", vbExclamation)
  Case EM_TEMPLATE_MISSING:       Call MsgBox("   .    ", vbExclamation)
  Case EM_INVALID_WIDTH:          Call MsgBox("  ", vbExclamation)
  Case EM_PYTHON_ERROR:           Call MsgBox(Fmt("Python error: {1}", unwrapped), vbInformation)
  
  Case IM_GENEARION_COMPLETE:     Call MsgBox(Fmt(" !" & vbNewLine & _
                                                  "  : {1}" & vbNewLine & _
                                                  "  : {2}", unwrapped), vbInformation)
  Case IM_EXPORT_DIFF_COMPLETE:   Call MsgBox("  ", vbInformation)
  Case IM_EXPORT_XL_COMPLETE:     Call MsgBox(" ", vbInformation)
    
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
  Case QM_CLEAR_ALL
    answer = MsgBox("     ?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
